diff -ruN strongswan-5.8.4/src/libcharon/plugins/stroke/stroke_list.c strongswancont-5.8.4-svc/src/libcharon/plugins/stroke/stroke_list.c
--- strongswan-5.8.4/src/libcharon/plugins/stroke/stroke_list.c	2020-03-29 11:59:15.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libcharon/plugins/stroke/stroke_list.c	2022-07-06 15:47:33.906969000 +0300
@@ -752,7 +752,18 @@
 	{
 		return FALSE;
 	}
-	if (public->get_fingerprint(public, KEYID_PUBKEY_SHA1, &keyid))
+
+	if(public->get_type(public) == KEY_BIGN)
+	{
+		if (public->get_fingerprint(public, KEYID_PUBKEY_BELT, &keyid))
+		{
+			id = identification_create_from_encoding(ID_KEY_ID, keyid);
+			private = lib->credmgr->get_private(lib->credmgr,
+										public->get_type(public), id, NULL);
+			id->destroy(id);
+		}
+	}
+	else if (public->get_fingerprint(public, KEYID_PUBKEY_SHA1, &keyid))	
 	{
 		id = identification_create_from_encoding(ID_KEY_ID, keyid);
 		private = lib->credmgr->get_private(lib->credmgr,
diff -ruN strongswan-5.8.4/src/libcharon/plugins/vici/vici_config.c strongswancont-5.8.4-svc/src/libcharon/plugins/vici/vici_config.c
--- strongswan-5.8.4/src/libcharon/plugins/vici/vici_config.c	2019-12-17 01:04:51.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libcharon/plugins/vici/vici_config.c	2023-05-13 16:25:54.224946000 +0300
@@ -335,6 +335,9 @@
 	char *mediated_by;
 	identification_t *peer_id;
 #endif /* ME */
+#ifdef _WIN32
+	bool block_dns;
+#endif /* _WIN32 */
 } peer_data_t;
 
 /**
@@ -445,6 +448,9 @@
 		DBG2(DBG_CFG, "  mediation_peer = %Y", data->peer_id);
 	}
 #endif /* ME */
+#ifdef _WIN32
+	DBG2(DBG_CFG, "  block_dns = %u", data->block_dns);
+#endif /* _WIN32 */
 
 	if (data->vips->get_count(data->vips))
 	{
@@ -1834,6 +1840,9 @@
 		{ "mediated_by",	parse_string,		&peer->mediated_by			},
 		{ "mediation_peer",	parse_peer_id,		&peer->peer_id				},
 #endif /* ME */
+#ifdef _WIN32
+		{ "block_dns",		parse_bool,			&peer->block_dns			},		
+#endif /* _WIN32 */
 	};
 
 	return parse_rules(rules, countof(rules), name, value,
@@ -2559,6 +2568,9 @@
 		.fragmentation = peer.fragmentation,
 		.childless = peer.childless,
 		.dscp = peer.dscp,
+#ifdef _WIN32
+		.block_dns = peer.block_dns,
+#endif /* _WIN32 */
 	};
 	ike_cfg = ike_cfg_create(&ike);
 
diff -ruN strongswan-5.8.4/src/libcharon/plugins/vici/vici_cred.c strongswancont-5.8.4-svc/src/libcharon/plugins/vici/vici_cred.c
--- strongswan-5.8.4/src/libcharon/plugins/vici/vici_cred.c	2018-10-23 20:03:28.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libcharon/plugins/vici/vici_cred.c	2023-04-30 14:50:33.174009000 +0300
@@ -172,6 +172,7 @@
 							  BUILD_BLOB_PEM, data,
 							  BUILD_X509_FLAG, ext_flag,
 							  BUILD_END);
+
 	if (!cert)
 	{
 		return create_reply("parsing %N certificate failed",
@@ -212,38 +213,83 @@
 	chunk_t data, fp;
 	char *str;
 
+	char params[2048] = {0};
+	char key_name[256] = {0};
+	char path[1024] = {0};
+	char pwd[256] = {0};
+
 	str = message->get_str(message, NULL, "type");
 	if (!str)
 	{
 		return create_reply("key type missing");
 	}
-	if (strcaseeq(str, "any"))
+	if (strcaseeq(str, "bign"))
 	{
-		type = KEY_ANY;
-	}
-	else if (strcaseeq(str, "rsa"))
-	{
-		type = KEY_RSA;
-	}
-	else if (strcaseeq(str, "ecdsa"))
-	{
-		type = KEY_ECDSA;
-	}
-	else if (strcaseeq(str, "bliss"))
-	{
-		type = KEY_BLISS;
+		type = KEY_BIGN;
+
+		str = message->get_str(message, NULL, "name");
+		if (!str)
+		{
+			return create_reply("bign key name missing");
+		}
+		data = chunk_from_hex(chunk_from_str(str), NULL);
+		memcpy(key_name, data.ptr, data.len);
+
+		str = message->get_str(message, NULL, "file");
+		if (!str)
+		{
+			return create_reply("second share key file path missing");
+		}
+		data = chunk_from_hex(chunk_from_str(str), NULL);
+		memcpy(path, data.ptr, data.len);
+
+		str = message->get_str(message, NULL, "pwd");
+		if (!str)
+		{
+			return create_reply("password missing");
+		}
+		data = chunk_from_hex(chunk_from_str(str), NULL);
+		memcpy(pwd, data.ptr, data.len);
+
+		sprintf(params, "PRIV_KEY=\"swanctl\\bpki\\PrivKey_%s.pkc\" PWD=\"%s\" SHARE_SECR1=\"swanctl\\bpki\\ShareKey1_%s.ssc\" SHARE_SECR2=\"%s\"",
+			    key_name, pwd, key_name, path);
+
+		memset(pwd, 0, 256);
+
+		key = lib->creds->create(lib->creds, CRED_PRIVATE_KEY, type,
+								 BUILD_BPKI_PARAMS, chunk_from_str(params),
+								 BUILD_END);
 	}
 	else
 	{
-		return create_reply("invalid key type: %s", str);
-	}
-	data = message->get_value(message, chunk_empty, "data");
-	if (!data.len)
-	{
-		return create_reply("key data missing");
-	}
-	key = lib->creds->create(lib->creds, CRED_PRIVATE_KEY, type,
-							 BUILD_BLOB_PEM, data, BUILD_END);
+		if (strcaseeq(str, "any"))
+		{
+			type = KEY_ANY;
+		}
+		else if (strcaseeq(str, "rsa"))
+		{
+			type = KEY_RSA;
+		}
+		else if (strcaseeq(str, "ecdsa"))
+		{
+			type = KEY_ECDSA;
+		}
+		else if (strcaseeq(str, "bliss"))
+		{
+			type = KEY_BLISS;
+		}
+		else
+		{
+			return create_reply("invalid key type: %s", str);
+		}
+		data = message->get_value(message, chunk_empty, "data");
+		if (!data.len)
+		{
+			return create_reply("key data missing");
+		}
+		key = lib->creds->create(lib->creds, CRED_PRIVATE_KEY, type,
+								 BUILD_BLOB_PEM, data, BUILD_END);
+	}	
 	if (!key)
 	{
 		return create_reply("parsing %N private key failed",
diff -ruN strongswan-5.8.4/src/libcharon/plugins/vici/vici_query.c strongswancont-5.8.4-svc/src/libcharon/plugins/vici/vici_query.c
--- strongswan-5.8.4/src/libcharon/plugins/vici/vici_query.c	2020-03-29 11:59:15.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libcharon/plugins/vici/vici_query.c	2023-06-15 15:57:18.846786000 +0300
@@ -51,12 +51,14 @@
 #ifdef HAVE_MALLINFO
 #include <malloc.h>
 #endif
+#include "locale.h"
 
 #include <daemon.h>
 #include <asn1/asn1.h>
 #include <credentials/certificates/certificate.h>
 #include <credentials/certificates/x509.h>
 #include <counters_query.h>
+#include <plugins/contactcrypto/contactcrypto_private_key.h>
 
 ENUM(vici_counter_type_names,
 	COUNTER_INIT_IKE_SA_REKEY, COUNTER_OUT_INFORMATIONAL_RSP,
@@ -112,6 +114,25 @@
 };
 
 /**
+ * Create a (error) reply message
+ */
+static vici_message_t* create_reply(char *fmt, ...)
+{
+	vici_builder_t *builder;
+	va_list args;
+
+	builder = vici_builder_create();
+	builder->add_kv(builder, "success", fmt ? "no" : "yes");
+	if (fmt)
+	{
+		va_start(args, fmt);
+		builder->vadd_kv(builder, "errmsg", fmt, args);
+		va_end(args);
+	}
+	return builder->finalize(builder);
+}
+
+/**
  * Add the given mark/mask to the message using the provided labels
  */
 static void add_mark(vici_builder_t *b, mark_t mark,
@@ -1057,7 +1078,9 @@
 	while (enumerator->enumerate(enumerator, &cert))
 	{
 		x509 = (x509_t*)cert;
-		if ((x509->get_flags(x509) & X509_ANY) != flag)
+
+		if (((x509->get_flags(x509) & X509_ANY) != flag) &&
+			!(x509->get_flags(x509) & flag) )
 		{
 			continue;
 		}
@@ -1665,6 +1688,597 @@
 	return b->finalize(b);
 }
 
+FILE* ext_fopen(const char*filename, const char*mode)
+{
+#ifdef _WIN32
+	int new_Len1 = 0;
+	int new_Len2 = 0;
+	int fn_len_s = strlen(filename);
+	int m_len_s  = strlen(mode);
+	if(fn_len_s==0) 
+		return NULL;
+	if(m_len_s==0)
+		return NULL;
+	wchar_t path[MAX_PATH];
+	wchar_t wmode[MAX_PATH];
+	new_Len1 = MultiByteToWideChar(CP_UTF8, 0, filename, fn_len_s, path, fn_len_s);
+	if(new_Len1>=MAX_PATH) return NULL;
+	path[new_Len1] = L'\0';
+	new_Len2 = MultiByteToWideChar(CP_UTF8, 0, mode, m_len_s, wmode, m_len_s);
+	if(new_Len2>=MAX_PATH) return NULL;
+	wmode[new_Len2] = L'\0';
+	return _wfopen(path, wmode);
+#else
+	return fopen(filename, mode);
+#endif
+}
+
+int ext_remove(const char*filename)
+{
+#ifdef _WIN32
+	int new_Len = 0;
+	int fn_len_s = strlen(filename);
+	if(fn_len_s==0) 
+		return NULL;
+	wchar_t path[MAX_PATH];
+	new_Len = MultiByteToWideChar(CP_UTF8, 0, filename, fn_len_s, path, fn_len_s);
+	if(new_Len>=MAX_PATH) return NULL;
+	path[new_Len] = L'\0';    
+	return _wremove(path);
+#else
+	return remove(filename);
+#endif
+}
+
+CALLBACK(build_certreq, vici_message_t*,
+	private_vici_query_t *this, char *name, u_int id, vici_message_t *request)
+{
+	chunk_t data, pass = chunk_empty, random = chunk_empty,
+			hash_init_data = chunk_empty, hekey_chunk = chunk_empty,
+			init_data = chunk_empty, certreq_chunk = chunk_empty,
+			privkey_chunk = chunk_empty, sharekey1_chunk = chunk_empty,
+			sharekey2_chunk = chunk_empty;
+	int validity;
+	bool add_gov_pki, use_78_ext_req;
+	char errmsg[1024], dn[4096] = {0}, key_name[256] = {0}, *temp,
+			out_file_certreq[1024] = {0}, out_file_privkey[1024] = {0},
+			out_file_sharekey1[1024] = {0}, out_file_sharekey2[1024]  = {0};
+	signature_params_t *scheme = NULL;
+	private_key_t *subj_private = NULL;
+	identification_t *subj_id = NULL;
+	certificate_t *subj_cert = NULL;
+	linked_list_t *san = linked_list_create();
+	identification_t *san_value = NULL;
+	shared_key_t *user_pwd = NULL, *high_entropy_key = NULL;
+	rng_t *rng = NULL;
+	prf_t *prf = NULL;
+	hasher_t *hasher = NULL;
+	uint8_t seed[32];
+	FILE *f;
+
+	memset(errmsg, 0, 1024);
+
+	// keyname
+	temp = request->get_str(request, NULL, "keyname");
+	if (!temp)
+	{
+		strcpy(errmsg, "key name missing");
+		goto end;
+	}
+	data = chunk_from_hex(chunk_from_str(temp), NULL);
+	memcpy(key_name, data.ptr, data.len);
+	chunk_free(&data);
+
+	sprintf(out_file_privkey, "swanctl\\bpki\\PrivKey_%s.pkc", key_name);
+	f = ext_fopen(out_file_privkey, "r");
+	if (f)
+	{
+		fclose(f);
+		strcpy(errmsg, "key with given name already exists");
+		goto end;
+	}
+	sprintf(out_file_sharekey1, "swanctl\\bpki\\ShareKey1_%s.ssc", key_name);
+
+	if (!strstr(lib->plugins->loaded_plugins(lib->plugins), "contactcrypto"))
+	{
+		strcpy(errmsg, "contactcrypto plugin isn't loaded");
+		goto end;
+	}
+
+	// dn
+	temp = request->get_str(request, NULL, "dn");
+	if (!temp)
+	{
+		strcpy(errmsg, "distinguished name missing");
+		goto end;
+	}
+	data = chunk_from_hex(chunk_from_str(temp), NULL);
+	memcpy(dn, data.ptr, data.len);	
+	chunk_free(&data);
+
+	// san
+	temp = request->get_str(request, NULL, "san");
+	if (temp)
+	{
+		san_value = identification_create_from_string(temp);
+		if (san_value)
+		{
+			san->insert_last(san, san_value);
+		}		
+	}
+
+	// validity
+	validity = request->get_int(request, 0, "validity");
+
+	// govpki
+	temp = request->get_str(request, NULL, "govpki");
+	add_gov_pki = (temp && !strcmp(temp, "true")) ? true : false;	
+
+	// extreq78
+	temp = request->get_str(request, NULL, "extreq78");
+	use_78_ext_req = (temp && !strcmp(temp, "true")) ? true : false;
+
+	// pass
+	temp = request->get_str(request, NULL, "pass");
+	if (!temp)
+	{
+		strcpy(errmsg, "private key password missing");
+		goto end;
+	}
+	pass = chunk_from_hex(chunk_from_str(temp), NULL);
+
+	// cert
+	temp = request->get_str(request, NULL, "cert");
+	if (!temp)
+	{
+		strcpy(errmsg, "output certification request path missing");
+		goto end;
+	}
+	data = chunk_from_hex(chunk_from_str(temp), NULL);
+	memcpy(out_file_certreq, data.ptr, data.len);
+	chunk_free(&data);
+
+	// sharekey2
+	temp = request->get_str(request, NULL, "sharekey2");
+	if (!temp)
+	{
+		strcpy(errmsg, "output second shared key path missing");
+		goto end;
+	}
+	data = chunk_from_hex(chunk_from_str(temp), NULL);
+	memcpy(out_file_sharekey2, data.ptr, data.len);
+	chunk_free(&data);
+
+	// random
+	temp = request->get_str(request, NULL, "random");
+	if (!temp)
+	{
+		strcpy(errmsg, "random missing");
+		goto end;
+	}
+	random = chunk_from_hex(chunk_from_str(temp), NULL);
+
+	// генерируем пару ключей
+	subj_private = lib->creds->create(lib->creds, CRED_PRIVATE_KEY, KEY_BIGN,
+									  BUILD_KEY_SIZE, 32,
+									  BUILD_KEY_INITIAL_RANDOM, random, BUILD_END);
+	if (!subj_private)
+	{
+		strcpy(errmsg, "generating key pair failed");
+		goto end;
+	}
+
+	// 
+	subj_id = identification_create_from_string(dn);
+	if (subj_id->get_type(subj_id) != ID_DER_ASN1_DN)
+	{
+		strcpy(errmsg, "supplied dn is not a distinguished name");
+		goto end;
+	}
+
+	// формируем запрос на выпуск сертификата
+	INIT(scheme,
+		.scheme = SIGN_BIGN_WITH_HBELT);
+
+	subj_cert = lib->creds->create(lib->creds,
+		CRED_CERTIFICATE, CERT_PKCS10_REQUEST,
+		BUILD_SIGNING_KEY, subj_private,
+		BUILD_SUBJECT, subj_id,
+		BUILD_SUBJECT_ALTNAMES, san,
+		BUILD_SIGNATURE_SCHEME, scheme,
+		BUILD_BPKI_PKCS10, TRUE,
+		BUILD_CERT_VALIDITY, validity,
+		BUILD_POLICY_GOVPKI, add_gov_pki,
+		BUILD_78_EXTS_REQUEST_OID, use_78_ext_req,
+		BUILD_END);
+	if (!subj_cert)
+	{
+		strcpy(errmsg, "generating certification request failed");
+		goto end;
+	}
+
+	// получаем 32 байта случайности из системного ГСЧ
+	rng = lib->crypto->create_rng(lib->crypto, RNG_STRONG);
+	if (!rng)
+	{
+		strcpy(errmsg, "no random number generator found");
+		goto end;
+	}
+	if (!rng_get_bytes_not_zero(rng, 32, seed, FALSE))
+	{
+		strcpy(errmsg, "failed to generate seed");
+		goto end;
+	}
+
+	// конкатенируем случайности, полученные из двух разных источников
+	init_data = chunk_cat("cc", chunk_create(seed, 32), random);
+
+	// хэшируем конкатенацию случайностей
+	hasher = lib->crypto->create_hasher(lib->crypto, BELT_HASH);
+	if (!hasher)
+	{
+		strcpy(errmsg, "no hasher found");
+		goto end;
+	}
+	if (!hasher->allocate_hash(hasher, init_data, &hash_init_data))
+	{
+		strcpy(errmsg, "failed to hash seed");
+		goto end;
+	}
+
+	// инициализируем ГСПЧ по СТБ 34.101.47 полученным хэш-значением
+	prf = lib->crypto->create_prf(lib->crypto, PRF_BRNG_HMAC_HBELT);
+	if (!prf)
+	{
+		strcpy(errmsg, "no pseudorandom number generator found");
+		goto end;
+	}
+	if (!prf->set_key(prf, hash_init_data))
+	{
+		strcpy(errmsg, "initializing pseudorandom number generator failed");
+		goto end;
+	}
+
+	// генерируем высокоэнтропийный ключ
+	hekey_chunk = chunk_alloca(16);
+	if (!prf->get_bytes(prf, hekey_chunk, NULL))
+	{
+		strcpy(errmsg, "generating high entropy key failed");
+		goto end;
+	}
+
+	// разделяем личный ключ на частичные секреты и формируем защищенные контейнеры
+	contactcrypto_private_key_t *private = (contactcrypto_private_key_t*)subj_private;
+	user_pwd = shared_key_create(SHARED_PRIVATE_KEY_PASS, chunk_clone(pass));
+	high_entropy_key = shared_key_create(SHARED_PRIVATE_KEY_PASS, chunk_clone(hekey_chunk));
+	memwipe(hekey_chunk.ptr, hekey_chunk.len);
+
+	if (!private->command(private, "build-containers", user_pwd, high_entropy_key,
+			&privkey_chunk, &sharekey1_chunk, &sharekey2_chunk))
+	{
+		strcpy(errmsg, "building private key containers failed");
+		goto end;
+	}
+
+	// ---------- save certification request
+	if (!subj_cert->get_encoding(subj_cert, CERT_ASN1_DER, &certreq_chunk))
+	{
+		strcpy(errmsg, "encoding certification request failed");
+		goto end;
+	}
+	f = ext_fopen(out_file_certreq, "wb");
+	if (!f)
+	{
+		strcpy(errmsg, "exporting certification request failed");
+		goto end;
+	}
+	if (fwrite(certreq_chunk.ptr, certreq_chunk.len, 1, f) != 1)
+	{
+		strcpy(errmsg, "writing certification request failed");
+		fclose(f);
+		goto end;
+	}
+	fclose(f);
+	DBG1(DBG_CNT, "certification request for \"%s\" "
+			"successfully built and written to \"%s\"", dn, out_file_certreq);
+
+	// ---------- save private key container
+	f = ext_fopen(out_file_privkey, "wb");
+	if (!f)
+	{
+		strcpy(errmsg, "exporting private key container failed");
+		goto end;
+	}
+	if (fwrite(privkey_chunk.ptr, privkey_chunk.len, 1, f) != 1)
+	{
+		strcpy(errmsg, "writing private key container failed");
+		fclose(f);
+		goto end;
+	}
+	fclose(f);
+	DBG1(DBG_CNT, "private key container for \"%s\" "
+			"successfully built and written to \"%s\"", dn, out_file_privkey);
+
+	// ---------- save first shared secret container
+	f = ext_fopen(out_file_sharekey1, "wb");
+	if (!f)
+	{
+		strcpy(errmsg, "exporting first shared secret container failed");
+		goto end;
+	}
+	if (fwrite(sharekey1_chunk.ptr, sharekey1_chunk.len, 1, f) != 1)
+	{
+		strcpy(errmsg, "writing first shared secret container failed");
+		fclose(f);
+		goto end;
+	}
+	fclose(f);
+	DBG1(DBG_CNT, "first shared secret container for \"%s\" "
+			"successfully built and written to \"%s\"", dn, out_file_sharekey1);
+
+	// ---------- save second shared secret container
+	f = ext_fopen(out_file_sharekey2, "wb");
+	if (!f)
+	{
+		strcpy(errmsg, "exporting second shared secret container failed");
+		goto end;
+	}
+	if (fwrite(sharekey2_chunk.ptr, sharekey2_chunk.len, 1, f) != 1)
+	{
+		strcpy(errmsg, "writing second shared secret container failed");
+		fclose(f);
+		goto end;
+	}
+	fclose(f);
+	DBG1(DBG_CNT, "second shared secret container for \"%s\" "
+			"successfully built and written to \"%s\"", dn, out_file_sharekey2);
+
+end:
+	san->destroy_offset(san, offsetof(identification_t, destroy));
+	DESTROY_IF(subj_private);
+	DESTROY_IF(subj_id);
+	DESTROY_IF(subj_cert);
+	DESTROY_IF(rng);
+	DESTROY_IF(hasher);
+	DESTROY_IF(prf);
+	signature_params_destroy(scheme);
+	chunk_clear(&pass);
+	chunk_clear(&random);
+	chunk_clear(&init_data);
+	chunk_clear(&hash_init_data);
+	DESTROY_IF(user_pwd);
+	DESTROY_IF(high_entropy_key);
+	if (certreq_chunk.ptr != NULL) chunk_free(&certreq_chunk);
+	if (privkey_chunk.ptr != NULL) chunk_free(&privkey_chunk);
+	if (sharekey1_chunk.ptr != NULL) chunk_free(&sharekey1_chunk);
+	if (sharekey2_chunk.ptr != NULL) chunk_free(&sharekey2_chunk);
+
+	if(errmsg[0]) {
+		return create_reply(errmsg);
+	}
+
+	vici_builder_t *b;
+	b = vici_builder_create();
+	b->add_kv(b, "success", "yes");	
+	return b->finalize(b);
+}
+
+CALLBACK(selftest, vici_message_t*,
+	private_vici_query_t *this, char *name, u_int id, vici_message_t *request)
+{
+	char errmsg[1024], *pos, buf[1024];
+	FILE *cmd = NULL;
+	char* crytpotest_bat = "basctl.bat";
+
+	cmd = popen(crytpotest_bat, "r");
+	if (!cmd)
+	{
+		DBG1(DBG_CNT, "self-testing failed: %s", strerror(errno));
+		strcpy(errmsg, "self-testing failed");
+		goto end;
+	}
+	while (TRUE)
+	{
+		if (!fgets(buf, sizeof(buf), cmd))
+		{
+			if (ferror(cmd))
+			{
+				DBG1(DBG_CNT, "self-testing failed: reading from script failed");
+				strcpy(errmsg, "self-testing failed");
+				goto end;
+			}
+			break;
+		}
+		else
+		{
+			pos = buf + strlen(buf);
+			if (pos > buf && pos[-1] == '\n')
+			{
+				pos[-1] = '\0';
+			}
+		}
+	}	
+	if (pclose(cmd) != 0)
+	{
+		DBG1(DBG_CNT, "self-testing failed");
+		strcpy(errmsg, "self-testing failed");
+		goto end;
+	}
+
+	DBG1(DBG_CNT, "self-testing completed successfully");
+	
+	vici_builder_t *b;
+	b = vici_builder_create();
+	b->add_kv(b, "success", "yes");	
+	return b->finalize(b);
+
+end:
+	if (cmd) pclose(cmd);
+	return create_reply(errmsg);
+}
+
+CALLBACK(remove_key, vici_message_t*,
+	private_vici_query_t *this, char *name, u_int id, vici_message_t *request)
+{
+	char *temp, key_name[256] = {0}, file_privkey[1048] = {0}, 
+		 pwd[256] = {0}, file_sharekey1[1048] = {0}, 
+		 file_sharekey2[1048] = {0}, params[2048] = {0};
+	chunk_t data;
+	FILE *f;
+	private_key_t *private = NULL;
+
+	if (!strstr(lib->plugins->loaded_plugins(lib->plugins), "contactcrypto"))
+	{
+		return create_reply("contactcrypto plugin isn't loaded");
+	}
+
+	// keyname
+	temp = request->get_str(request, NULL, "keyname");
+	if (!temp)
+	{
+		return create_reply("key name missing");
+	}
+	data = chunk_from_hex(chunk_from_str(temp), NULL);
+	memcpy(key_name, data.ptr, data.len);
+	chunk_free(&data);
+	
+	sprintf(file_privkey, "swanctl\\bpki\\PrivKey_%s.pkc", key_name);
+	f = ext_fopen(file_privkey, "r");
+	if (!f)
+	{
+		return create_reply("key with given name does not exist");
+	}
+	fclose(f);
+	sprintf(file_sharekey1, "swanctl\\bpki\\ShareKey1_%s.ssc", key_name);
+
+	// pass
+	temp = request->get_str(request, NULL, "pass");
+	if (!temp)
+	{
+		return create_reply("private key password missing");
+	}
+	data = chunk_from_hex(chunk_from_str(temp), NULL);
+
+	memcpy(pwd, data.ptr, data.len);
+	chunk_free(&data);
+
+	// sharekey2
+	temp = request->get_str(request, NULL, "sharekey2");
+	if (!temp)
+	{
+		return create_reply("second shared key path missing");
+	}
+	data = chunk_from_hex(chunk_from_str(temp), NULL);
+	memcpy(file_sharekey2, data.ptr, data.len);
+	chunk_free(&data);
+
+	sprintf(params, "PRIV_KEY=\"%s\" PWD=\"%s\" SHARE_SECR1=\"%s\" SHARE_SECR2=\"%s\"",
+			file_privkey, pwd, file_sharekey1, file_sharekey2);
+	
+	data = chunk_from_str(params);
+	private = lib->creds->create(lib->creds, CRED_PRIVATE_KEY, KEY_BIGN,
+								 BUILD_BPKI_PARAMS, data, BUILD_END);
+	if (!private)
+	{
+		return create_reply("private key inputs verification failed");
+	}
+	private->destroy(private);
+
+	// удаляем файлы контейнеров
+	if (ext_remove(file_privkey))
+	{
+		return create_reply("removing private key container failed");
+	}
+	ext_remove(file_sharekey1);
+	ext_remove(file_sharekey2);
+
+	DBG1(DBG_CNT, "private key \"%s\" successfully removed", key_name);
+
+	vici_builder_t *b;
+	b = vici_builder_create();
+	b->add_kv(b, "success", "yes");	
+	return b->finalize(b);
+}
+
+CALLBACK(bign_verify, vici_message_t*,
+	private_vici_query_t *this, char *name, u_int id, vici_message_t *request)
+{
+	chunk_t temp, *data_chunk = NULL, *sig_chunk = NULL;
+	char *str, data_file[1024] = {0}, sig_file[1024] = {0};
+	certificate_t *cert = NULL;
+	public_key_t* pubkey = NULL;
+	bool is_valid;
+	
+	if (!strstr(lib->plugins->loaded_plugins(lib->plugins), "contactcrypto"))
+	{
+		return create_reply("contactcrypto plugin isn't loaded");
+	}
+
+	// file
+	str = request->get_str(request, NULL, "file");
+	if (!str)
+	{
+		return create_reply("data file path missing");
+	}
+	temp = chunk_from_hex(chunk_from_str(str), NULL);
+	memcpy(data_file, temp.ptr, temp.len);
+	chunk_free(&temp);
+
+	// signature
+	str = request->get_str(request, NULL, "signature");
+	if (!str)
+	{
+		return create_reply("signature file path missing");
+	}
+	temp = chunk_from_hex(chunk_from_str(str), NULL);
+	memcpy(sig_file, temp.ptr, temp.len);
+	chunk_free(&temp);
+
+	cert = lib->creds->create(lib->creds, CRED_CERTIFICATE, CERT_X509,
+							  BUILD_FROM_FILE, "contact_code_signing.cer", BUILD_END);
+	if(!cert)
+	{
+		return create_reply("parse certificate failed");
+	}
+
+	pubkey = cert->get_public_key(cert);
+	if(!pubkey)
+	{
+		DESTROY_IF(cert);
+		return create_reply("get public key failed");
+	}
+	DESTROY_IF(cert);
+
+	if(!(data_chunk = chunk_map(data_file, FALSE)))
+	{
+		DESTROY_IF(pubkey);
+		return create_reply("read data file failed");
+ 	}
+ 	if(!(sig_chunk = chunk_map(sig_file, FALSE)))
+	{
+		chunk_unmap(data_chunk);
+		DESTROY_IF(pubkey);
+		return create_reply("read signature file failed");
+ 	}
+
+	is_valid = pubkey->verify(pubkey, SIGN_BIGN_WITH_HBELT,
+		                      NULL, *data_chunk, *sig_chunk);
+
+	chunk_unmap(data_chunk);
+	chunk_unmap(sig_chunk);
+	DESTROY_IF(pubkey);
+
+	if (!is_valid)
+	{
+		return create_reply("signature is not valid");
+	}
+
+	vici_builder_t *b;
+	b = vici_builder_create();
+	b->add_kv(b, "success", "yes");	
+	return b->finalize(b);
+}
+
 static void manage_command(private_vici_query_t *this,
 						   char *name, vici_command_cb_t cb, bool reg)
 {
@@ -1694,6 +2308,10 @@
 	manage_command(this, "reset-counters", reset_counters, reg);
 	manage_command(this, "version", version, reg);
 	manage_command(this, "stats", stats, reg);
+	manage_command(this, "build-certreq", build_certreq, reg);
+	manage_command(this, "selftest", selftest, reg);
+	manage_command(this, "remove-key", remove_key, reg);
+	manage_command(this, "bign-verify", bign_verify, reg);
 }
 
 METHOD(listener_t, ike_updown, bool,
diff -ruN strongswan-5.8.4/src/libcharon/sa/authenticator.c strongswancont-5.8.4-svc/src/libcharon/sa/authenticator.c
--- strongswan-5.8.4/src/libcharon/sa/authenticator.c	2020-03-29 11:59:15.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libcharon/sa/authenticator.c	2022-07-06 15:47:34.526979000 +0300
@@ -27,11 +27,12 @@
 #include <encoding/payloads/auth_payload.h>
 
 
-ENUM_BEGIN(auth_method_names, AUTH_RSA, AUTH_DSS,
+ENUM_BEGIN(auth_method_names, AUTH_RSA, AUTH_BIGN,
 	"RSA signature",
 	"pre-shared key",
-	"DSS signature");
-ENUM_NEXT(auth_method_names, AUTH_ECDSA_256, AUTH_DS, AUTH_DSS,
+	"DSS signature",
+	"BIGN signature");
+ENUM_NEXT(auth_method_names, AUTH_ECDSA_256, AUTH_DS, AUTH_BIGN,
 	"ECDSA-256 signature",
 	"ECDSA-384 signature",
 	"ECDSA-521 signature",
@@ -98,6 +99,7 @@
 	switch (auth_payload->get_auth_method(auth_payload))
 	{
 		case AUTH_RSA:
+		case AUTH_BIGN:
 		case AUTH_ECDSA_256:
 		case AUTH_ECDSA_384:
 		case AUTH_ECDSA_521:
@@ -138,6 +140,10 @@
 			return (authenticator_t*)pubkey_v1_authenticator_create(ike_sa,
 										initiator, dh, dh_value, sa_payload,
 										id_payload, KEY_RSA);
+		case AUTH_BIGN:
+			return (authenticator_t*)pubkey_v1_authenticator_create(ike_sa,
+										initiator, dh, dh_value, sa_payload,
+										id_payload, KEY_BIGN);
 		case AUTH_ECDSA_256:
 		case AUTH_ECDSA_384:
 		case AUTH_ECDSA_521:
diff -ruN strongswan-5.8.4/src/libcharon/sa/authenticator.h strongswancont-5.8.4-svc/src/libcharon/sa/authenticator.h
--- strongswan-5.8.4/src/libcharon/sa/authenticator.h	2020-03-29 11:59:15.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libcharon/sa/authenticator.h	2022-07-06 15:47:34.510979000 +0300
@@ -58,7 +58,12 @@
 	 * DSS private key over a SHA-1 hash.
 	 */
 	AUTH_DSS = 3,
-
+	
+	/**
+	 *	Computed as in STB 34.101.45
+	 */
+	AUTH_BIGN = 4,
+	
 	/**
 	 * ECDSA with SHA-256 on the P-256 curve as specified in RFC 4754
 	 */
diff -ruN strongswan-5.8.4/src/libcharon/sa/eap/eap_method.h strongswancont-5.8.4-svc/src/libcharon/sa/eap/eap_method.h
--- strongswan-5.8.4/src/libcharon/sa/eap/eap_method.h	2020-03-29 11:59:15.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libcharon/sa/eap/eap_method.h	2022-07-06 15:47:34.526979000 +0300
@@ -113,11 +113,17 @@
 	 *
 	 * Not all EAP methods establish a shared secret. For implementations of
 	 * the EAP-Identity method, get_msk() returns the received identity.
+	 * 
+	 * @note Returning NOT_SUPPORTED is important for implementations of EAP
+	 * methods that don't establish an MSK.  In particular as client because
+	 * key-generating EAP methods MUST fail to process EAP-Success messages if
+	 * no MSK is established.
 	 *
 	 * @param msk			chunk receiving internal stored MSK
 	 * @return
-	 *						- SUCCESS, or
+	 *						- SUCCESS, if MSK is established
 	 * 						- FAILED, if MSK not established (yet)
+	 * 						- NOT_SUPPORTED, for non-MSK-establishing methods
 	 */
 	status_t (*get_msk) (eap_method_t *this, chunk_t *msk);
 
